diff --git a/SHADE_Engine/src/Math/SHQuaternion.cpp b/SHADE_Engine/src/Math/SHQuaternion.cpp
index 33c568a5..3564916a 100644
--- a/SHADE_Engine/src/Math/SHQuaternion.cpp
+++ b/SHADE_Engine/src/Math/SHQuaternion.cpp
@@ -36,44 +36,18 @@ namespace SHADE
   : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
   {}
 
+  SHQuaternion::SHQuaternion(const SHVec4& vec4) noexcept
+  : XMFLOAT4( vec4.x, vec4.y, vec4.z, vec4.w )
+  {}
+
   SHQuaternion::SHQuaternion(float _x, float _y, float _z, float _w) noexcept
   : XMFLOAT4( _x, _y, _z, _w )
   {}
 
-  SHQuaternion::SHQuaternion(float yaw, float pitch, float roll) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    XMStoreFloat4(this, XMQuaternionRotationRollPitchYaw(pitch, yaw, roll));
-  }
-
-  SHQuaternion::SHQuaternion(const SHVec3& eulerAngles) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    const XMVECTOR V = XMLoadFloat3(&eulerAngles);
-    XMStoreFloat4(this, XMQuaternionRotationRollPitchYawFromVector(V));
-  }
-
-  SHQuaternion::SHQuaternion(const SHVec3& axis, float angleInRad) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    const XMVECTOR AXIS = XMLoadFloat3(&axis);
-    XMStoreFloat4(this, XMQuaternionRotationAxis(AXIS, angleInRad));
-  }
-
-  SHQuaternion::SHQuaternion(const SHMatrix& rotationMatrix) noexcept
-  : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
-  {
-    const XMMATRIX M = XMLoadFloat4x4(&rotationMatrix);
-    XMStoreFloat4(this, XMQuaternionRotationMatrix(M));
-  }
-
   SHQuaternion::SHQuaternion(const reactphysics3d::Vector3& rp3dEuler) noexcept
   : XMFLOAT4( 0.0f, 0.0f, 0.0f, 1.0f )
   {
-    const SHVec3& SHADE_VEC{ rp3dEuler };
-
-    const XMVECTOR V = XMLoadFloat3(&SHADE_VEC);
-    XMStoreFloat4(this, XMQuaternionRotationRollPitchYawFromVector(V));
+    XMStoreFloat4(this, XMQuaternionRotationRollPitchYawFromVector(SHVec3 { rp3dEuler }));
   }
 
   SHQuaternion::SHQuaternion(const reactphysics3d::Quaternion& rp3dQuat) noexcept
@@ -113,10 +87,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    XMStoreFloat4(&result, XMVectorAdd(Q1, Q2));
+    XMStoreFloat4(&result, XMVectorAdd(*this, rhs));
     return result;
   }
 
@@ -124,10 +95,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    XMStoreFloat4(&result, XMVectorSubtract(Q1, Q2));
+    XMStoreFloat4(&result, XMVectorSubtract(*this, rhs));
     return result;
   }
 
@@ -135,9 +103,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-
-    XMStoreFloat4(&result, XMVectorNegate(Q));
+    XMStoreFloat4(&result, XMVectorNegate(*this));
     return result;
   }
 
@@ -145,10 +111,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    XMStoreFloat4(&result, XMQuaternionMultiply(Q1, Q2));
+    XMStoreFloat4(&result, XMQuaternionMultiply(*this, rhs));
     return result;
   }
 
@@ -156,9 +119,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-
-    XMStoreFloat4(&result, XMVectorScale(Q, rhs));
+    XMStoreFloat4(&result, XMVectorScale(*this, rhs));
     return result;
   }
 
@@ -166,27 +127,18 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMQuaternionInverse(XMLoadFloat4(&rhs));
-
-    XMStoreFloat4(&result, XMQuaternionMultiply(Q1, Q2));
+    XMStoreFloat4(&result, XMQuaternionMultiply(*this, XMQuaternionInverse(rhs)));
     return result;
   }
 
   bool SHQuaternion::operator==(const SHQuaternion& rhs) const noexcept
   {
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    return XMQuaternionEqual(Q1, Q2);
+    return XMQuaternionEqual(*this, rhs);
   }
 
   bool SHQuaternion::operator!=(const SHQuaternion& rhs) const noexcept
   {
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    return XMQuaternionNotEqual(Q1, Q2);
+    return XMQuaternionNotEqual(*this, rhs);
   }
 
   SHQuaternion::operator reactphysics3d::Quaternion() const noexcept
@@ -199,6 +151,11 @@ namespace SHADE
     return reactphysics3d::Vector3{ ToEuler() };
   }
 
+  SHQuaternion::operator XMVECTOR() const noexcept
+  {
+    return XMLoadFloat4(this);
+  }
+
   SHQuaternion operator*(float lhs, const SHQuaternion& rhs) noexcept
   {
     return rhs * lhs;
@@ -213,8 +170,7 @@ namespace SHADE
     XMVECTOR axis;
     float angle;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-    XMQuaternionToAxisAngle(&axis, &angle, Q);
+    XMQuaternionToAxisAngle(&axis, &angle, *this);
     return angle;
   }
 
@@ -223,8 +179,7 @@ namespace SHADE
     XMVECTOR axis;
     float angle;
 
-    const XMVECTOR Q = XMLoadFloat4(this);
-    XMQuaternionToAxisAngle(&axis, &angle, Q);
+    XMQuaternionToAxisAngle(&axis, &angle, *this);
 
 
     return SHVec4{XMVectorGetX(axis), XMVectorGetY(axis), XMVectorGetZ(axis), angle};
@@ -238,64 +193,49 @@ namespace SHADE
 
   void SHQuaternion::Invert() noexcept
   {
-    const XMVECTOR Q = XMLoadFloat4(this);
-    XMStoreFloat4(this, XMQuaternionInverse(Q));
+    XMStoreFloat4(this, XMQuaternionInverse(*this));
   }
 
   float SHQuaternion::Length() const noexcept
   {
-    const XMVECTOR Q = XMLoadFloat4(this);
-    return XMVectorGetX(XMQuaternionLength(Q));
+    return XMVectorGetX(XMQuaternionLength(*this));
   }
 
   float SHQuaternion::LengthSquared() const noexcept
   {
-    const XMVECTOR Q = XMLoadFloat4(this);
-    return XMVectorGetX(XMQuaternionLengthSq(Q));
+    return XMVectorGetX(XMQuaternionLengthSq(*this));
   }
 
   float SHQuaternion::Dot(const SHQuaternion& rhs) const noexcept
   {
-    const XMVECTOR Q1 = XMLoadFloat4(this);
-    const XMVECTOR Q2 = XMLoadFloat4(&rhs);
-
-    return XMVectorGetX(XMQuaternionDot(Q1, Q2));
-  }
-
-  SHQuaternion SHQuaternion::RotateTowards(const SHQuaternion&, float) const noexcept
-  {
-    SHQuaternion result;
-
-    // TODO (Diren)
-
-    return result;
+    return XMVectorGetX(XMQuaternionDot(*this, rhs));
   }
 
   SHVec3 SHQuaternion::ToEuler() const noexcept
   {
-    const float xx = x * x;
-    const float yy = y * y;
-    const float zz = z * z;
+    const float XX = x * x;
+    const float YY = y * y;
+    const float ZZ = z * z;
 
-    const float m31 = 2.f * x * z + 2.f * y * w;
-    const float m32 = 2.f * y * z - 2.f * x * w;
-    const float m33 = 1.f - 2.f * xx - 2.f * yy;
+    const float M_31 = 2.f * x * z + 2.f * y * w;
+    const float M_32 = 2.f * y * z - 2.f * x * w;
+    const float M_33 = 1.f - 2.f * XX - 2.f * YY;
 
-    const float cy = sqrtf(m33 * m33 + m31 * m31);
-    const float cx = atan2f(-m32, cy);
-    if (cy > 16.0f * SHMath::EPSILON)
+    const float CY = sqrtf(M_33 * M_33 + M_31 * M_31);
+    const float CX = atan2f(-M_32, CY);
+    if (CY > 16.0f * SHMath::EPSILON)
     {
-        const float m12 = 2.f * x * y + 2.f * z * w;
-        const float m22 = 1.f - 2.f * xx - 2.f * zz;
+      const float M_12 = 2.f * x * y + 2.f * z * w;
+      const float M_22 = 1.f - 2.f * XX - 2.f * ZZ;
 
-        return SHVec3(cx, atan2f(m31, m33), atan2f(m12, m22));
+      return SHVec3(CX, atan2f(M_31, M_33), atan2f(M_12, M_22));
     }
     else
     {
-        const float m11 = 1.f - 2.f * yy - 2.f * zz;
-        const float m21 = 2.f * x * y - 2.f * z * w;
+      const float m11 = 1.f - 2.f * YY - 2.f * ZZ;
+      const float m21 = 2.f * x * y - 2.f * z * w;
 
-        return SHVec3(cx, 0.f, atan2f(-m21, m11));
+      return SHVec3(CX, 0.f, atan2f(-m21, m11));
     }
   }
 
@@ -311,13 +251,43 @@ namespace SHADE
   /* Static Function Member Definitions                                                */
   /*-----------------------------------------------------------------------------------*/
 
+  SHQuaternion SHQuaternion::FromEuler(const SHVec3& eulerAngles) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationRollPitchYawFromVector(eulerAngles));
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::FromPitchYawRoll(float pitch, float yaw, float roll) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationRollPitchYaw(pitch, yaw, roll));
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::FromAxisAngle(const SHVec3& axis, float angle) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationAxis(axis, angle));
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::FromRotationMatrix(const SHMatrix& rotationMatrix) noexcept
+  {
+    SHQuaternion result;
+
+    XMStoreFloat4(&result, XMQuaternionRotationMatrix(rotationMatrix));
+    return result;
+  }
+
   SHQuaternion SHQuaternion::Normalise(const SHQuaternion& q) noexcept
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(&q);
-    
-    XMStoreFloat4(&result, XMQuaternionNormalize(Q));
+    XMStoreFloat4(&result, XMQuaternionNormalize(q));
     return result;
   }
 
@@ -325,9 +295,7 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(&q);
-    
-    XMStoreFloat4(&result, XMQuaternionConjugate(Q));
+    XMStoreFloat4(&result, XMQuaternionConjugate(q));
     return result;
   }
 
@@ -335,26 +303,37 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q = XMLoadFloat4(&q);
-    XMStoreFloat4(&result, XMQuaternionInverse(Q));
-
+    XMStoreFloat4(&result, XMQuaternionInverse(q));
     return result;
   }
 
 
-  float SHQuaternion::Angle(const SHQuaternion&, const SHQuaternion&) noexcept
+  float SHQuaternion::Angle(const SHQuaternion& q1, const SHQuaternion& q2) noexcept
   {
-    // TODO (Diren)
+    XMVECTOR R = XMQuaternionMultiply(XMQuaternionConjugate(q1), q2);
 
-    return 0.0f;
+    const float RS = XMVectorGetW(R);
+    R = XMVector3Length(R);
+    return 2.0f * atan2f(XMVectorGetX(R), RS);
   }
 
-  SHQuaternion SHQuaternion::Lerp(const SHQuaternion&, const SHQuaternion&, float) noexcept
+  SHQuaternion SHQuaternion::Lerp(const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept
   {
     SHQuaternion result;
 
-    // TODO (Diren)
+    XMVECTOR R = XMVectorZero();
+    if (XMVector4GreaterOrEqual(XMVector4Dot(q1, q2), R))
+    {
+      R = XMVectorLerp(q1, q2, t);
+    }
+    else
+    {
+      const XMVECTOR X0 = XMVectorMultiply(q1, XMVectorReplicate(1.f - t));
+      const XMVECTOR X1 = XMVectorMultiply(q2, XMVectorReplicate(t));
+      R = XMVectorSubtract(X0, X1);
+    }
 
+    XMStoreFloat4(&result, XMQuaternionNormalize(R));
     return result;
   }
 
@@ -362,19 +341,105 @@ namespace SHADE
   {
     SHQuaternion result;
 
-    const XMVECTOR Q1 = XMLoadFloat4(&q1);
-    const XMVECTOR Q2 = XMLoadFloat4(&q2);
-
-    XMStoreFloat4(&result, XMQuaternionSlerp(Q1, Q2, t));
+    XMStoreFloat4(&result, XMQuaternionSlerp(q1, q2, t));
     return result;
   }
 
-  SHQuaternion SHQuaternion::Rotate(const SHVec3& , const SHVec3&) noexcept
+  SHQuaternion SHQuaternion::ClampedLerp(const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin, float tMax) noexcept
+  {
+    return Lerp(q1, q2, std::clamp(t, tMin, tMax));
+  }
+
+
+  SHQuaternion SHQuaternion::ClampedSlerp(const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin, float tMax) noexcept
+  {
+    return Slerp(q1, q2, std::clamp(t, tMin, tMax));
+  }
+
+  SHQuaternion SHQuaternion::FromToRotation(const SHVec3& from, const SHVec3& to) noexcept
+  {
+    // Melax, "The Shortest Arc Quaternion", Game Programming Gems
+
+    SHQuaternion result;
+
+    const XMVECTOR F = XMVector3Normalize(from);
+    const XMVECTOR T = XMVector3Normalize(to);
+
+    const float dot = XMVectorGetX(XMVector3Dot(F, T));
+    if (dot >= 1.f)
+    {
+        result = Identity;
+    }
+    else if (dot <= -1.f)
+    {
+        XMVECTOR axis = XMVector3Cross(F, SHVec3::Right);
+        if (XMVector3NearEqual(XMVector3LengthSq(axis), g_XMZero, g_XMEpsilon))
+        {
+            axis = XMVector3Cross(F, SHVec3::Up);
+        }
+
+        const XMVECTOR Q = XMQuaternionRotationAxis(axis, XM_PI);
+        XMStoreFloat4(&result, Q);
+    }
+    else
+    {
+        const XMVECTOR C = XMVector3Cross(F, T);
+        XMStoreFloat4(&result, C);
+
+        const float s = sqrtf((1.f + dot) * 2.f);
+        result.x /= s;
+        result.y /= s;
+        result.z /= s;
+        result.w = s * 0.5f;
+    }
+
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::LookRotation(const SHVec3& forward, const SHVec3& up) noexcept
   {
     SHQuaternion result;
 
-    // TODO (Diren)
+    const SHQuaternion Q1 = FromToRotation(SHVec3::Forward, forward);
 
+    const XMVECTOR C = XMVector3Cross(forward, up);
+    if (XMVector3NearEqual(XMVector3LengthSq(C), g_XMZero, g_XMEpsilon))
+    {
+        // forward and up are co-linear
+        return Q1;
+    }
+
+    SHVec3 qU;
+    XMStoreFloat3(&qU, XMQuaternionMultiply(Q1, SHVec3::Up));
+
+    const SHQuaternion Q2 = FromToRotation(qU, up);
+
+    XMStoreFloat4(&result, XMQuaternionMultiply(Q2, Q1));
+
+    return result;
+  }
+
+  SHQuaternion SHQuaternion::RotateTowards(const SHQuaternion& from, const SHQuaternion& to, float maxAngleInRad) noexcept
+  {
+    SHQuaternion result;
+
+    // We can use the conjugate here instead of inverse assuming q1 & q2 are normalized.
+    const XMVECTOR R = XMQuaternionMultiply(XMQuaternionConjugate(from), to);
+
+    const float RS = XMVectorGetW(R);
+    const XMVECTOR L = XMVector3Length(R);
+    const float angle = 2.f * atan2f(XMVectorGetX(L), RS);
+    if (angle > maxAngleInRad)
+    {
+        const XMVECTOR delta = XMQuaternionRotationAxis(R, maxAngleInRad);
+        const XMVECTOR Q = XMQuaternionMultiply(delta, from);
+        XMStoreFloat4(&result, Q);
+    }
+    else
+    {
+        // Don't overshoot.
+        result = to;
+    }
     return result;
   }
 
diff --git a/SHADE_Engine/src/Math/SHQuaternion.h b/SHADE_Engine/src/Math/SHQuaternion.h
index c94907b5..fa5b5d36 100644
--- a/SHADE_Engine/src/Math/SHQuaternion.h
+++ b/SHADE_Engine/src/Math/SHQuaternion.h
@@ -49,11 +49,8 @@ namespace SHADE
     SHQuaternion  (SHQuaternion&& rhs)      = default;
 
     SHQuaternion  ()                                            noexcept;
+    SHQuaternion  (const SHVec4& vec4)                          noexcept;
     SHQuaternion  (float x, float y, float z, float w)          noexcept;
-    SHQuaternion  (float yaw, float pitch, float roll)          noexcept;
-    SHQuaternion  (const SHVec3& eulerAngles)                   noexcept;
-    SHQuaternion  (const SHVec3& axis, float angleInRad)        noexcept;
-    SHQuaternion  (const SHMatrix& rotationMatrix)              noexcept;
 
     // Conversion from other math types
 
@@ -87,6 +84,7 @@ namespace SHADE
 
     operator reactphysics3d::Quaternion       ()                        const noexcept;
     operator reactphysics3d::Vector3          ()                        const noexcept;
+    operator DirectX::XMVECTOR                ()                        const noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Getter Functions                                                                */
@@ -99,29 +97,37 @@ namespace SHADE
     /* Function Members                                                                */
     /*---------------------------------------------------------------------------------*/
 
-    void                        Invert        ()                                                      noexcept;
+    void                        Invert        ()  noexcept;
 
-    [[nodiscard]] float         Length        ()                                                const noexcept;
-    [[nodiscard]] float         LengthSquared ()                                                const noexcept;
-    [[nodiscard]] float         Dot           (const SHQuaternion& rhs)                         const noexcept;
-    [[nodiscard]] SHQuaternion  RotateTowards (const SHQuaternion& target, float maxAngleInRad) const noexcept;
+    [[nodiscard]] float         Length        ()  const noexcept;
+    [[nodiscard]] float         LengthSquared ()  const noexcept;
+    [[nodiscard]] float         Dot           (const SHQuaternion& rhs) const noexcept;
 
-    [[nodiscard]] SHVec3        ToEuler       ()                                                const noexcept;
-    [[nodiscard]] std::string   ToString      ()                                                const noexcept;
+    [[nodiscard]] SHVec3        ToEuler       ()  const noexcept;
+    [[nodiscard]] std::string   ToString      ()  const noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Static Function Members                                                         */
     /*---------------------------------------------------------------------------------*/
 
-    [[nodiscard]] static SHQuaternion Normalise (const SHQuaternion& q)                                   noexcept;
-    [[nodiscard]] static SHQuaternion Conjugate (const SHQuaternion& q)                                   noexcept;
-    [[nodiscard]] static SHQuaternion Inverse   (const SHQuaternion& q)                                   noexcept;
-    [[nodiscard]] static float        Angle     (const SHQuaternion& q1, const SHQuaternion& q2)          noexcept;
+    [[nodiscard]] static SHQuaternion FromEuler         (const SHVec3& eulerAngles)           noexcept;
+    [[nodiscard]] static SHQuaternion FromPitchYawRoll  (float pitch, float yaw, float roll)  noexcept;
+    [[nodiscard]] static SHQuaternion FromAxisAngle     (const SHVec3& axis, float angle)     noexcept;
+    [[nodiscard]] static SHQuaternion FromRotationMatrix(const SHMatrix& rotationMatrix)      noexcept;
 
-    [[nodiscard]] static SHQuaternion Lerp      (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
-    [[nodiscard]] static SHQuaternion Slerp     (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
+    [[nodiscard]] static SHQuaternion Normalise         (const SHQuaternion& q) noexcept;
+    [[nodiscard]] static SHQuaternion Conjugate         (const SHQuaternion& q) noexcept;
+    [[nodiscard]] static SHQuaternion Inverse           (const SHQuaternion& q) noexcept;
+    [[nodiscard]] static float        Angle             (const SHQuaternion& q1, const SHQuaternion& q2) noexcept;
 
-    [[nodiscard]] static SHQuaternion Rotate    (const SHVec3& from, const SHVec3& to)                    noexcept;
+    [[nodiscard]] static SHQuaternion Lerp              (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
+    [[nodiscard]] static SHQuaternion Slerp             (const SHQuaternion& q1, const SHQuaternion& q2, float t) noexcept;
+    [[nodiscard]] static SHQuaternion ClampedLerp       (const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin = 0.0f, float tMax = 1.0f) noexcept;
+    [[nodiscard]] static SHQuaternion ClampedSlerp      (const SHQuaternion& q1, const SHQuaternion& q2, float t, float tMin = 0.0f, float tMax = 1.0f) noexcept;
+
+    [[nodiscard]] static SHQuaternion FromToRotation  (const SHVec3& from, const SHVec3& to)    noexcept;
+    [[nodiscard]] static SHQuaternion LookRotation    (const SHVec3& forward, const SHVec3& up) noexcept;
+    [[nodiscard]] static SHQuaternion RotateTowards   (const SHQuaternion& from, const SHQuaternion& to, float maxAngleInRad) noexcept;
   };
 
   SHQuaternion operator*(float lhs, const SHQuaternion& rhs) noexcept;
diff --git a/SHADE_Engine/src/Math/Transform/SHTransform.cpp b/SHADE_Engine/src/Math/Transform/SHTransform.cpp
index f51d73ec..ef7c5fda 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransform.cpp
+++ b/SHADE_Engine/src/Math/Transform/SHTransform.cpp
@@ -26,15 +26,15 @@ namespace SHADE
   /*-----------------------------------------------------------------------------------*/
 
   SHTransform::SHTransform() noexcept
-  : position  { SHVec3::Zero }
-  , rotation  { SHVec3::Zero }
-  , scale     { SHVec3::One  }
+  : position    { SHVec3::Zero }
+  , orientation { SHQuaternion::Identity }
+  , scale       { SHVec3::One  }
   {}
 
   SHTransform::SHTransform(const SHVec3& pos, const SHVec3& rot, const SHVec3& scl) noexcept
-  : position  { pos }
-  , rotation  { rot }
-  , scale     { scl }
+  : position    { pos }
+  , orientation { SHQuaternion::FromEuler(rot) }
+  , scale       { scl }
   {}
 
   /*-----------------------------------------------------------------------------------*/
@@ -43,12 +43,12 @@ namespace SHADE
 
   bool SHTransform::operator==(const SHTransform& rhs) const noexcept
   {
-    return !(position != rhs.position || rotation != rhs.rotation || scale != rhs.scale);
+    return !(position != rhs.position || orientation != rhs.orientation || scale != rhs.scale);
   }
 
   bool SHTransform::operator!=(const SHTransform& rhs) const noexcept
   {
-    return (position != rhs.position || rotation != rhs.rotation || scale != rhs.scale);
+    return (position != rhs.position || orientation != rhs.orientation || scale != rhs.scale);
   }
 
   /*-----------------------------------------------------------------------------------*/
@@ -59,7 +59,7 @@ namespace SHADE
   {
     
     const SHMatrix T = SHMatrix::Translate(position);
-    const SHMatrix R = SHMatrix::Rotate(rotation);
+    const SHMatrix R = SHMatrix::Rotate(orientation);
     const SHMatrix S = SHMatrix::Scale(scale);
 
     trs = S * R * T;
diff --git a/SHADE_Engine/src/Math/Transform/SHTransform.h b/SHADE_Engine/src/Math/Transform/SHTransform.h
index c1a0e565..2e7d236c 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransform.h
+++ b/SHADE_Engine/src/Math/Transform/SHTransform.h
@@ -12,8 +12,8 @@
 
 // Project Headers
 #include "SH_API.h"
-#include "Math/Vector/SHVec2.h"
 #include "Math/Vector/SHVec3.h"
+#include "Math/SHQuaternion.h"
 #include "Math/SHMatrix.h"
 
 namespace SHADE
@@ -31,22 +31,23 @@ namespace SHADE
 
     static const SHTransform Identity;
 
-    SHVec3    position;
-    SHVec3    rotation;
-    SHVec3    scale;
+    SHVec3        position;
+    SHQuaternion  orientation;
+    SHVec3        scale;
 
-    SHMatrix  trs;
+    SHMatrix      trs;
 
     /*---------------------------------------------------------------------------------*/
     /* Constructors & Destructor                                                       */
     /*---------------------------------------------------------------------------------*/
     
-    SHTransform             (const SHTransform&)  = default;
-    SHTransform             (SHTransform&&)       = default;
-    ~SHTransform            ()                    = default;
+    SHTransform   (const SHTransform&)  = default;
+    SHTransform   (SHTransform&&)       = default;
+    ~SHTransform  ()                    = default;
 
-    SHTransform             ()                                                        noexcept;
-    SHTransform             (const SHVec3& pos, const SHVec3& rot, const SHVec3& scl) noexcept;
+    SHTransform   ()                                                                noexcept;
+    SHTransform   (const SHVec3& pos, const SHVec3& rot, const SHVec3& scl)         noexcept;
+    SHTransform   (const SHVec3& pos, const SHQuaternion& quat, const SHVec3& scl)  noexcept;
 
     /*---------------------------------------------------------------------------------*/
     /* Operator Overloads                                                              */
@@ -63,7 +64,6 @@ namespace SHADE
     /*---------------------------------------------------------------------------------*/
 
     const SHMatrix& ComputeTRS();
-
   };
 
 } // namespace SHADE
\ No newline at end of file
diff --git a/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp b/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp
index 949cfa67..e56cbc8d 100644
--- a/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp
+++ b/SHADE_Engine/src/Math/Transform/SHTransformComponent.cpp
@@ -12,6 +12,8 @@
 
 // Primary Header
 #include "SHTransformComponent.h"
+// Project Headers
+#include "Math/SHMathHelpers.h"
 
 namespace SHADE
 {
@@ -40,7 +42,12 @@ namespace SHADE
 
   const SHVec3& SHTransformComponent::GetLocalRotation() const noexcept
   {
-    return local.rotation;
+    return localRotation;
+  }
+
+  const SHQuaternion& SHTransformComponent::GetLocalOrientation() const noexcept
+  {
+    return local.orientation;
   }
 
   const SHVec3& SHTransformComponent::GetLocalScale() const noexcept
@@ -55,7 +62,12 @@ namespace SHADE
 
   const SHVec3& SHTransformComponent::GetWorldRotation() const noexcept
   {
-    return world.rotation;
+    return worldRotation;
+  }
+
+  const SHQuaternion& SHTransformComponent::GetWorldOrientation() const noexcept
+  {
+    return world.orientation;
   }
 
   const SHVec3& SHTransformComponent::GetWorldScale() const noexcept
@@ -91,16 +103,28 @@ namespace SHADE
   void SHTransformComponent::SetLocalRotation(const SHVec3& newLocalRotation) noexcept
   {
     dirty = true;
-    local.rotation = newLocalRotation;
+
+    localRotation = newLocalRotation;
+    updateQueue.push({ UpdateCommandType::LOCAL_ROTATION, newLocalRotation });
   }
 
   void SHTransformComponent::SetLocalRotation(float pitch, float yaw, float roll) noexcept
   {
     dirty = true;
 
-    local.rotation.x = pitch;
-    local.rotation.y = yaw;
-    local.rotation.z = roll;
+    localRotation.x = pitch;
+    localRotation.y = yaw;
+    localRotation.z = roll;
+
+    updateQueue.push({ UpdateCommandType::LOCAL_ROTATION, SHVec3{pitch, yaw, roll} });
+  }
+
+  void SHTransformComponent::SetLocalOrientation(const SHQuaternion& newLocalOrientation) noexcept
+  {
+    dirty = true;
+
+    local.orientation = newLocalOrientation;
+    updateQueue.push({ UpdateCommandType::LOCAL_ORIENTATION, newLocalOrientation });
   }
 
   void SHTransformComponent::SetLocalScale(const SHVec3& newLocalScale) noexcept
@@ -121,7 +145,7 @@ namespace SHADE
   {
     dirty = true;
 
-    world.rotation = newWorldRotation;
+    worldRotation = newWorldRotation;
     updateQueue.push({ UpdateCommandType::WORLD_ROTATION, newWorldRotation });
   }
 
@@ -129,13 +153,21 @@ namespace SHADE
   {
     dirty = true;
 
-    world.rotation.x = pitch;
-    world.rotation.y = yaw;
-    world.rotation.z = roll;
+    worldRotation.x = pitch;
+    worldRotation.y = yaw;
+    worldRotation.z = roll;
 
     updateQueue.push({ UpdateCommandType::WORLD_ROTATION, SHVec3{ pitch, yaw, roll} });
   }
 
+  void SHTransformComponent::SetWorldOrientation(const SHQuaternion& newWorldOrientation) noexcept
+  {
+    dirty = true;
+
+    world.orientation = newWorldOrientation;
+    updateQueue.push({ UpdateCommandType::WORLD_ORIENTATION, newWorldOrientation });
+  }
+
   void SHTransformComponent::SetWorldScale(const SHVec3& newWorldScale) noexcept
   {
     dirty = true;
@@ -153,6 +185,6 @@ RTTR_REGISTRATION
 
   registration::class_<SHTransformComponent>("Transform Component")
     .property("Translate" , &SHTransformComponent::GetLocalPosition , &SHTransformComponent::SetLocalPosition                                       )
-    .property("Rotate"    , &SHTransformComponent::GetLocalRotation , select_overload<void(SHVec3 const&)>(&SHTransformComponent::SetLocalRotation) )
+    .property("Rotate"    , &SHTransformComponent::GetLocalRotation , select_overload<void(const SHVec3&)>(&SHTransformComponent::SetLocalRotation) )
     .property("Scale"     , &SHTransformComponent::GetLocalScale    , &SHTransformComponent::SetLocalScale                                          );
 }
\ No newline at end of file
